/*
* Distributed Computational System
* Server Plugin API
*
* $Id: server_plugin.h,v 1.4 2001/11/29 07:06:17 kris Exp $
*/

#ifndef _SERVER_PLUGIN_H
#define _SERVER_PLUGIN_H

/** Data Structures **/

typedef struct _server_chunk_t {
	unsigned char chunk_id[16];	/* guid for this chunk */
	unsigned short chunk_type;	/* error-checking/original chunk */
	unsigned short problem_id;	/* what problem (plugin) does this chunk go with? */
	long len;			/* length of the chunk data */
	unsigned char *data;		/* chunk data */
} server_chunk_t;

#define FREE_CHUNK_DATA(c) if( (c).data ) free( (c).data )

/* function typedefs */
typedef int (*sp_init_f)( int );
typedef int (*sp_getversion_f)( void );
typedef int (*sp_getproblemchunk_f)( server_chunk_t * );
typedef int (*sp_completedchunk_f)( server_chunk_t * );

/** Function Prototypes **/

/* Functions to be implemented in the plugin */

int SP_Init( int plugin_id );
int SP_GetVersion( void );
int SP_GetProblemChunk( server_chunk_t *chunk );
int SP_CompletedChunk( server_chunk_t *chunk );

#endif /* _SERVER_PLUGIN_H */
